//========================================================
// xkugel.cpp -- Spiegelkugel mit Beschriftung mit speziellem Font
// 9. Juli 2000  geaendert am 10 September 2014
// To compile:
//   Make
// To run:
//  ./xkugel        als root kompiliert und gelinkt !
//==============================================================
/*
// g++ Xkugel2.cpp -o Xkugel2 -lX11 -lm
// g++ -o Xkugel2 Xkugel2.cpp -L/usr/X11R6/lib -lX11 -lm


   Zeitmessung mit dem folgenden Befehl:
   bash-2.03# time ./xkugel

   real    0m0.894s
   user    0m0.620s
   sys     0m0.040s

   bei einer Aufloesung von 800x600:
   real    0m1.752s
   user    0m1.330s
   sys     0m0.010s
*/

#include <iostream>
#include <stdio.h>      // Need sprintf()
#include <stdlib.h>     // Need exit()
#include <string.h>     // Need strlen()
#include <math.h>

#include <X11/Xlib.h>   // Most X programs need these headers
#include <X11/Xutil.h>
#include <X11/Xos.h>
#define Pi 3.141592653589793;

using namespace std;

// #define  vt pt                      // vector wird durch point ersetzt

Display *display;       // X server display structure

#define MAXCOLORS 16     // Number of colors in following arrays
// ForrestGreen NavyBlue gray0 DimGray AntiqueWhite  gray0 bis gray100
const char *Roy_G_Biv[] = {
  "Red",            // 0
  "Orange",         // 1
  "LightBlue",      // 2
  "Yellow",         // 3
  "Blue",           // 4
  "Violet",         // 5 Indigo
  "DarkViolet",     // 6 Violet
  "NavyBlue",       // 7
  "AntiqueWhite",   // 8
  "DarkBlue",       // 9
  "gray12",         // 10    dunkel
  "gray25",         // 11
  "gray40",         // 12
  "gray60",         // 13
  "gray80",         // 14
  "gray90"          // 15     hell
};

unsigned long colors[ MAXCOLORS ];
Window win;
GC gc;
int intWidth = 640;    // intDisplayWidth / 3;
int intHeight = 480;   //intDisplayHeight / 4;

 XFontStruct *font1; //*font2, *font3;  // Font structure pointers
const char *ueberschrift[50] = {"Spiegelkugel"};

// prototypes
void GetColors(unsigned long intDefaultColor);
void GetFont( char *fontName, XFontStruct** font);

void kugel();
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

int main()
{
  // Attempt to extablish communications with the X Server
  //
  display = XOpenDisplay(NULL);
  if (display == NULL) {
    std::cerr << "Failure connecting to X Server";
    exit(1);
  }

  // Calculate window's dimensions and position
  //
  int intScreenNum = DefaultScreen(display);
  int intDisplayWidth = DisplayWidth(display, intScreenNum);
  int intDisplayHeight = DisplayHeight(display, intScreenNum);

  int intXPos = 0;
  int intYPos = 0;

  // Get the most basic of colors (black and white)
  //
  int intBlackColor, intWhiteColor;
  intBlackColor = BlackPixel(display, DefaultScreen(display));
  intWhiteColor = WhitePixel(display, DefaultScreen(display));

  // Create window (this does not make it visible)
  //Window
  win =
  XCreateSimpleWindow(
    display,                         // X server display struct
    DefaultRootWindow(display),      // Parent window
    intXPos, intYPos,                // Position
    intWidth, intHeight,             // Window width & height
    0,                               // Border width (default)
    intBlackColor, intWhiteColor);   // Background, foreground


   // Fill global colors array using intBlackColor for the
  // default color if any allocation fails.
  //
  GetColors(intBlackColor);

  // Assign a name for the window title bar (probably)
  //
  XStoreName(display, win," Raytracer: ");
/*
  // Create variables needed for XAllocNamedColor()
  //
     Colormap colormap = DefaultColormap(display, intScreenNum);
   char * colorname = "AntiqueWhite";

  // ForrestGreen NavyBlue gray0 DimGray AntiqueWhite  gray0 bis gray100
    XColor screenColor, exactColor;



  // Allocate color. Exit if operation fails.
  //
  if (!XAllocNamedColor(display, colormap, colorname,
			&screenColor, &exactColor)) {
    cerr << "Cannot allocate color " << colorname << endl;
    exit(1);
  }
*/

  // Create a graphics context for our window
  //
  XGCValues gc_values;
  unsigned long gc_mask = GCForeground | GCLineWidth;
  //gc_values.foreground = screenColor.pixel;
  gc_values.line_width = 1;
  //GC
  gc = XCreateGC(display, win, gc_mask, &gc_values);

  //  Alternative for a default GC
  //  GC gc = XCreateGC(display, win, 0, NULL);
  //  XSetForeground(display, gc, screenColor.pixel);

  // Load some fonts. You might have to change the strings.
  // Run the xfont program to list them. Program ends if any
  // named font is unavailable.
  //

   //  const char *fontName1[8] = {"10x20"};
  // const char *fontName1[] = {"10x20"};
  // GetFont(fontName1, &font1);
   const char * fontName1 = "-*-helvetica-*-r-*-*-28-*-*-*-*-*-*-*";
   font1 = XLoadQueryFont (display, fontName1);
    /* If the font could not be loaded, revert to the "fixed" font. */
    if (! font1) {
        fprintf (stderr, "unable to load font %s: using fixed\n", fontName1);
        font1 = XLoadQueryFont (display, "fixed");
    } 
   GetFont((char *)fontName1,&font1); 

  // Map the window to the display
  // Window is visible when first Expose event is received
  //
  XMapWindow(display, win);

  // Specify the types of events we want to receive
  //
  XSelectInput(display, win,
    ExposureMask | KeyPressMask ); // | ButtonPressMask | ButtonReleaseMask | Button1MotionMask);

  // Mouse movement and button event loop
  // with double-clicking.
  //
  bool done = false;
  //bool mouseDown = false;
  //int x1, x2, y1, y2;
  //x1 = 30; y1 = 22; x2 = 598; y2 = 400;
  Time lastTime = 0;
  XEvent event;
  while (!done) {
    XNextEvent(display, &event);
    switch (event.type) {

      case Expose:
        kugel();
        break;

   // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      case KeyPress:
       std::cout << "Keypress detected" << std::endl;
       done = true;   // Exit on any keypress
       break;
    }
  }
  // Unload all fonts loaded by GetFont
  //
  // if (font1 != NULL) XUnloadFont(display, font1->fid);

  // Disconnect X server connection and exit.
  // (Program may never get to here)
  //
  XCloseDisplay(display);
  return 0;
}

  // ************************************************************************

 // Allocate global colors array using intDefaultColor if a
// named color cannot be allocated for any reason.
void GetColors(unsigned long intDefaultColor)
{
  Colormap colormap = DefaultColormap(display, DefaultScreen(display));
  XColor screenColor, exactColor;

  for (int i = 0; i < MAXCOLORS; i++) {
    if (!XAllocNamedColor(display, colormap, Roy_G_Biv[i],&screenColor, &exactColor)) {
      std::cerr << "Color " << Roy_G_Biv[i] << " unavailable" << std::endl;
      std::cerr << "using 'black' in its place." << std::endl;
      colors[i] = intDefaultColor;
    } else {
      colors[i] = screenColor.pixel;
    }
  }
}

// Load font from X server.
// On many servers, a default font is loaded if the specified.
// one is unavailable, so the error message is rarely seen.

void GetFont(char *fontName, XFontStruct** font)
{
  *font = XLoadQueryFont(display, fontName);
  if (font == NULL)
    std::cerr << "Font " << fontName << " is not available" << std::endl;
}



void kugel()
{

  int col;                                    // Nummer der Pixelfarbe

  double a,b,c,d;  // Koeffizienten der quadratischen Gleichung
		   // mehrfach benutzt
  double lambda;   // mehrfach benutzt Parameter in Geradengleichung
  double disk;     // 2 fach benutzt:1. fuer Schnittpunkt Kugel mit Sehstrahl
		   // s1,s2,s3
		   //              2. fuer Schnittpunkt Kugel mit Lichtstrahl
		   // t1,t2,t3 der von der Lichtquelle li ausgeht

  // ---------------- Koerper:
  double m1, m2, m3, r;                        // Kugelmittelpunkt und Radius

  // ----------------- Blickvektor:
  double bw2;                           // halber Blickwinkel des Beobachters
  double tanbw2;                                //  Tangens von Blickwinkel/2
  double fak;           // Entfernung des Beobachters vom Bildschirm in Pixel
			// fak = (XAufloesung/2)/tan((Blickwinkel/2)))
  double mx,my;         // Kehrwert von fak = Entfernung des Beobachters vom
			// Bildschirm in Pixeln gerechnet

  double bv1,bv2,bv3,betrag; //noch nicht normierter Blickvektor fuer Eingabe
			     //und dessen Betrag zur Normierung
  double b1,b2,b3;      // Blickvektor von beob zum Mittelpunkt der Bildebene
			// jetzt aber normiert
  double kb;            // = Verhaeltnis b2/b1 des Blickvektors

  // allgemeine Raytracer Variablen :
  double beob1, beob2, beob3;                              // Beobachterpunkt
  double li1, li2, li3;                                    // Lichtquelle

  double h1,h2,h3;      // aktueller Schnittpunkt mit dem Koerper
			// Hilfsvar. fuer bestimmten Punkt
  double norm1,norm2,norm3;     // Normalvektor der Kugel zeigt vom Mittelpkt
				// nach aussen
  double s1,s2,s3; // Sehstrahl fuer einen einzelnen Punkt aendert sich
		   // dauernd fuer jeden aktuellen Punkt
  double t1,t2,t3; // neuer Sehstrahl von der Lichtquelle auf die Schachbrett
		   // ebene fuer die Schattenberechnung
  double k1,k2;    // Koordinaten in der Schachbrettebene x3 = k3 = 0
  double da,dc,dd,cf,df;
  double nenner;   // Nenner fuer Reflektionsberechnung
  int rest,sum;    // fuer Schachbrettmuster

  // ----------- Koordinatensysteme:
				     // Welt: rechts x1,x2,x3
  double eu1,eu2,eu3,ev1,ev2,ev3;    // eu, ev Einheitsvektoren der Bildebene
				     // eu nach rechts ev nach unten
				     // Bildebene links
  int xs, ys;             // echte Geraetekoordinaten 0 .. 639 0..479
			  // Ursprung links oben !
  int xss,yss;            // Geraetekoordinaten bezogen auf Schirmmittelpunkt
			  // Ursprung liegt im Mittelpunkt des Bildschirms
			  // xss -320 .. 320  yss -240 .. 240



  // clrscr();
  m1 = 104.0;  m2 = 114.7;  m3 = 1.0;  r = 1.0;	               // Kugel
  li1 = 120.0;  li2 = 120.0;  li3 = 30.0;                      // Lichtquelle
  beob1 = 100.0;   beob2 = 100.0;   beob3 = 4.5;               // Beobachter
  da = 1.7;    // Seitenlaenge der gleichseitigen Dreiecke des Bodens


  bw2 = 10.0;                       // halber Oeffnungswinkel des Beobachters
				    // in Grad
  bw2 = bw2/180.0*Pi;               // halber Oeffnungswinkel in Radiant
  tanbw2 = sin(bw2)/cos(bw2);       // Tangens des halben Oeffnungswinkels
  fak = intWidth/2.0/tanbw2;       // fak =(XAufloesung/2)/tan((Blickwinkel/2)))
  mx = 1.0/fak;                // Kehrwert von fak 1814.5
  my = 1.0/fak;
  bv1 = 0.210274;               // vorlauefiger nicht normierter Blickvektor
  bv2 = 0.938484;               // fuer Eingabe
  bv3 = -0.253442;
  betrag = sqrt(bv1*bv1+bv2*bv2+bv3*bv3);
  b1 = bv1/betrag;              // normierter Blickvektor
  b2 = bv2/betrag;
  b3 = bv3/betrag;

  kb = b2/b1;                 // Verhaeltnis der Komponenten des Blickvektors
			      // bei der Projektion auf die horizontale X1 X2
			      // Ebene = Schachbrettebene
  eu1 = kb/sqrt(1.0+kb*kb);   // eu zeigt nach rechts
  eu2 = -1.0/sqrt(1.0+kb*kb); // eu3 = 0.0 Bildebeneoberkante parallel zur
			      // x1,x2 Ebene. Das bedeutet eine immer waag=
			      // recht gehaltene Kamera.
  ev1 = -b3*eu2;              // ev zeigt nach unten. Eu und ev = Linkssystem
  ev2 = b3*eu1;
  ev3 = b1*eu2-b2*eu1;

  //  GrSetMode(GR_default_graphics);
  // cleardevice();

  for(ys=0;ys<intHeight;ys++)
  {
   for(xs=0;xs<intWidth;xs++)
   {
    xss = xs - 320; yss = ys -240;          // modifizierte Schirmkoordinaten

    s1 = b1+eu1*mx*xss+ev1*my*yss;          // Sehstrahl
    s2 = b2+eu2*mx*xss+ev2*my*yss;
    s3 = b3+ev3*my*yss;

    a = ( s1*s1 + s2*s2 + s3*s3 ) / (r*r);
    b = 2.0*(beob1*s1 - m1*s1 + beob2*s2 - s2*m2 + beob3*s3 - s3*m3)/(r*r);
    c = ((beob1-m1)*(beob1-m1) + (beob2-m2)*(beob2-m2) +
	  (beob3-m3)*(beob3-m3) ) / (r*r) -1;
    disk = (b*b) - 4.0*a*c;
    if( disk < 0.0 )		      // Strahl trifft die Kugel nicht !
      {			              // daher kein Schnitt mit Kugel
       if (s3 < 0.0) {                // Strahl geht nach unten daher muss
	 lambda = -beob3 / s3;        // Schachbrettmuster gezeichnet werden
	 k1 = lambda*s1 + beob1;
	 k2 = lambda*s2 + beob2;
/*	 sum = (int)(floor(k1) + floor(k2));
	 rest = sum%2;                      // weisses oder schwarzes Quadrat
	 if (rest == 0) col = 0; else col = 15;
       } else col = 11;        */         // Strahl geht in den Himmwel

    dc = (k1 - k2/1.73205081) / da;           // sqrt(3)
    dd = 2.0 * k2 /(da * 1.73205081);
    cf = dc - floor(dc);
    df = dd - floor(dd);
    if((cf + df) >= 1.0) col = 0;
      else col = 15;
     } else col = 11;



      }
    if( disk >= 0.0 )                           // ab jetzt Schnitt mit Kugel
     {
      lambda = -( b + sqrt (disk) ) / (2.0*a);
      h1 = beob1 + lambda*s1;
      h2 = beob2 + lambda*s2;
      h3 = beob3 + lambda*s3;
      norm1 = h1-m1;                                // Normalvektor der Kugel
      norm2 = h2-m2;
      norm3 = h3-m3;
      nenner = norm1*norm1 + norm2*norm2 + norm3*norm3;
      d = 2.0 * ( s1*norm1 + s2*norm2 + s3*norm3 ) / nenner;
      s1 = s1 - d*norm1;               //jetzt s1,s2,s3 reflektierter Strahl
      s2 = s2 - d*norm2;
      s3 = s3 - d*norm3;
		// reflektierter Sehstrahl hat einen Schnittpunkt mit der
		// horizontalen = Schachbrettebene wenn s3 < 0 ist
		// ist s3 > 0 wird geht reflektierte Sehstrahlin den Himmel
     if(s3 < 0.0)           // ab jetzt reflektierter Strahl geht nach unten
      {
       lambda = -h3 / s3;
       k1 = lambda*s1 + h1;
       k2 = lambda*s2 + h2;
       sum = (int)(floor(k1) + floor(k2));
       rest = sum%2;
 /*      if (rest == 0) col = 0; else col = 7;    
                         // weisses oder schwarzes Quadrat
          }else col = 1;                // blauer Himmel bei s3 > 0 */

    dc = (k1 - k2/1.73205081) / da;           // sqrt(3)
    dd = 2.0 * k2 /(da * 1.73205081);
    cf = dc - floor(dc);
    df = dd - floor(dd);
    if((cf + df) >= 1.0) col = 0;
      else col = 7;
     } else col = 1;
   }
	  // Schattenberechnung:
    t1 = k1 - li1;
    t2 = k2 - li2;
    t3 = -li3;

    a = (t1*t1 + t2*t2 + t3*t3) /r/r;
    b = 2.0* (li1*t1 - m1*t1 + li2*t2 - t2*m2 + li3*t3 -t3*m3) / (r*r);
    c = ( (li1-m1)*(li1-m1) + (li2-m2)*(li2-m2) + (li3-m3)*(li3-m3))/(r*r)-1.0;
    disk = (b*b) - 4.0*a*c;
    if (disk >= 0.0) {
    if ((col == 7 )||(col == 15)) col = 8;  //  Eigen-und Schlagschatten
    else col = 11;
    }
      if (col == 0)  XSetForeground(display, gc, colors[7]); //
      if (col == 7)  XSetForeground(display, gc, colors[13]);//
      if (col == 8)  XSetForeground(display, gc, colors[11]);//
      if (col == 1)  XSetForeground(display, gc, colors[2]); // 2=LightBlue
      if (col == 11) XSetForeground(display, gc, colors[10]); //
      if (col == 15) XSetForeground(display, gc, colors[12]);//

      XDrawPoint(display, win, gc,xs, ys);
   }
  }
  XSetForeground(display, gc, colors[3]);//
  XSetFont(display, gc, font1->fid);    
  XDrawString(display, win, gc, 10, 20, *ueberschrift, strlen(*ueberschrift));
}
